#
# Conditional build:
%bcond_without	tests		# build without tests

Summary:	mold: A Modern Linker
Name:		mold
Version:	2.4.1
Release:	1
License:	MIT
Group:		Development/Libraries
Source0:	https://github.com/rui314/mold/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	c25b000b233d683940ebd597ea9c5d93
URL:		https://github.com/rui314/mold
BuildRequires:	blake3-devel
BuildRequires:	cmake >= 3.14
%{?with_tests:BuildRequires:	glibc-static}
%ifarch %{armv6} riscv64
BuildRequires:	libatomic-devel
%endif
BuildRequires:	libstdc++-devel >= 6:10
%{?with_tests:BuildRequires:	libstdc++-static >= 6:10}
BuildRequires:	mimalloc-devel >= 1.7
BuildRequires:	rpmbuild(macros) >= 2.007
BuildRequires:	tbb-devel >= 2021.3.0
BuildRequires:	zlib-devel
BuildRequires:	zstd-devel
Requires:	mimalloc >= 1.7
Requires:	tbb >= 2021.3.0
ExclusiveArch:	%{ix86} %{x8664} %{arm} aarch64 m68k ppc64 ppc64le riscv32 riscv64 s390x sparc64
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
mold is a faster drop-in replacement for existing Unix linkers. It is
several times faster than LLVM lld linker, the second-fastest
open-source linker which I originally created a few years ago. mold is
created for increasing developer productivity by reducing build time
especially in rapid debug-edit-rebuild cycles.

%prep
%setup -q

%{__rm} -r third-party/{mimalloc,tbb}

%build
%cmake -B build \
	%{cmake_on_off tests BUILD_TESTING} \
	-DMOLD_USE_MIMALLOC:BOOL=ON \
	-DMOLD_USE_SYSTEM_MIMALLOC:BOOL=ON \
	-DMOLD_USE_SYSTEM_TBB:BOOL=ON

%{__make} -C build

%if %{with tests}
%{__make} -C build test
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc LICENSE README.md docs/*.md
%attr(755,root,root) %{_bindir}/ld.mold
%attr(755,root,root) %{_bindir}/mold
%dir %{_libdir}/mold
%attr(755,root,root) %{_libdir}/mold/mold-wrapper.so
%dir %{_libexecdir}/mold
%attr(755,root,root) %{_libexecdir}/mold/ld
%{_mandir}/man1/mold.1*
%{_mandir}/man1/ld.mold.1*
%changelog
* Sat Mar 02 2024 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/mold.git;a=log;h=master

* Fri Mar 01 2024 Jan Palus <atler@pld-linux.org> cc9b90a
- up to 2.4.1

* Thu Nov 30 2023 Jan Palus <atler@pld-linux.org> d078aa1
- up to 2.4.0

* Tue Nov 14 2023 Jan Palus <atler@pld-linux.org> ae0de18
- up to 2.3.3

* Sat Nov 04 2023 Jan Palus <atler@pld-linux.org> 2b7eceb
- up to 2.3.2

* Fri Oct 20 2023 Jan Palus <atler@pld-linux.org> a29d4b9
- up to 2.3.1

* Wed Oct 18 2023 Jan Palus <atler@pld-linux.org> 2c5d005
- up to 2.3.0

* Sun Sep 24 2023 Jan Palus <atler@pld-linux.org> 609ab98
- up to 2.2.0

* Sun Aug 13 2023 Jan Palus <atler@pld-linux.org> c56bdd5
- up to 2.1.0

* Wed Jul 26 2023 Jan Palus <atler@pld-linux.org> ec19151
- up to 2.0.0

* Thu Mar 16 2023 Jan Palus <atler@pld-linux.org> da61b38
- up to 1.11.0

* Sun Jan 22 2023 Jan Palus <atler@pld-linux.org> 73d6c35
- up to 1.10.1

* Fri Jan 20 2023 Jan Palus <atler@pld-linux.org> cfa309c
- up to 1.10.0

* Fri Jan 06 2023 Jan Palus <atler@pld-linux.org> ec1edbc
- up to 1.9.0

* Mon Dec 26 2022 Jan Palus <atler@pld-linux.org> 75ee2d6
- up to 1.8.0

* Fri Nov 18 2022 Jan Palus <atler@pld-linux.org> bb347c5
- up to 1.7.1

* Sun Nov 13 2022 Jan Palus <atler@pld-linux.org> 7aad5a4
- more supported archs

* Sun Nov 13 2022 Jan Palus <atler@pld-linux.org> 5ef7b19
- up to 1.7.0

* Wed Oct 19 2022 Jan Palus <atler@pld-linux.org> e26d185
- upstream fixes for x86 32bit non-PIC failures; rel 2

* Wed Oct 19 2022 Jan Palus <atler@pld-linux.org> ddd5c32
- up to 1.6.0

* Thu Sep 29 2022 Jan Palus <atler@pld-linux.org> 309afd1
- up to 1.5.1

